function [modelFileName compartment biomassDrain metConnections objFxn lbub] = loadExcel(fileName)
[fileType fileSheets] = xlsfinfo(fileName);

modelFileName = '';
compartment = {};
biomassDrain = {};
metConnections = {};
objFxn = {};
lbub = {};

for i = 1:length(fileSheets)
    switch fileSheets{i}
        case 'sbml'
            [num txt] = xlsread(fileName,'sbml');
            modelFileName = txt{1};
            
        case 'compartment'
            [num txt raw] = xlsread(fileName,'compartment');
            
            raw(1,:) = [];
            maxCol = 6;
            if size(raw,2) > maxCol
                raw(:,maxCol+1:end) = [];
            end
            for j = 1:size(raw,1)
                for k = 1:size(raw,2)
                    if ischar(raw{j,k});
                        raw{j,k} = strtrim(raw{j,k});
                    elseif isnan(raw{j,k})
                        raw{j,k}='';
                    end
                end
            end
            for j = size(raw,1):-1:1
                if length(raw{j,1})==0
                    raw(j,:) = [];
                elseif isnan(raw{j,1})
                    raw(j,:) = [];
                end
            end
            compartment = raw;
            
        case 'biomassDrain'
            [num txt raw] = xlsread(fileName,'biomassDrain');
            raw(1,:) = [];
            
            for j = 1:size(raw,2)
                if length(raw{1,j})==0
                    raw(:,j:end) = [];
                    break
                elseif isnan(raw{1,j})
                    raw(:,j:end) = [];
                    break
                end
            end
            
            for j = 1:size(raw,1)
                for k = 1:size(raw,2)
                    if ischar(raw{j,k});
                        raw{j,k} = strtrim(raw{j,k});
                    elseif isnan(raw{j,k})
                        raw{j,k}='';
                    end
                end
            end
            for j = size(raw,1):-1:1
                if length(raw{j,1})==0
                    raw(j,:) = [];
                elseif isnan(raw{j,1})
                    raw(j,:) = [];
                end
            end
            biomassDrain = raw;
            
        case 'metConnections'
            [num txt raw] = xlsread(fileName,'metConnections');
            raw(1,:) = [];
            maxCol = 7;
            if size(raw,2) > maxCol
                raw(:,maxCol+1:end) = [];
            end
            for j = 1:size(raw,1)
                for k = 1:size(raw,2)
                    if ischar(raw{j,k});
                        raw{j,k} = strtrim(raw{j,k});
                    elseif isnan(raw{j,k})
                        raw{j,k}='';
                    end
                end
            end
            for j = size(raw,1):-1:1
                if length(raw{j,1})==0
                    raw(j,:) = [];
                elseif isnan(raw{j,1})
                    raw(j,:) = [];
                end
            end
            metConnections = raw;
            
        case 'objFxn'
            [num txt raw] = xlsread(fileName,'objFxn');
            raw(1,:) = [];
             maxCol = 7;
            if size(raw,2) > maxCol
                raw(:,maxCol+1:end) = [];
            end
            for j = size(raw,1):-1:1
                if length(raw{j,1})==0
                    raw(j,:) = [];
                elseif isnan(raw{j,1})
                    raw(j,:) = [];
                end
            end
            objFxn = raw;
            
        case 'lbub'
            [num txt raw] = xlsread(fileName,'lbub');
            raw(1,:) = [];
             maxCol = 8;
            if size(raw,2) > maxCol
                raw(:,maxCol+1:end) = [];
            end
            for j = 1:size(raw,1)
                for k = 1:size(raw,2)
                    if ischar(raw{j,k});
                        raw{j,k} = strtrim(raw{j,k});
                    elseif isnan(raw{j,k})
                        raw{j,k}='';
                    end
                end
            end
            for j = size(raw,1):-1:1
                if length(raw{j,1})==0
                    raw(j,:) = [];
                elseif isnan(raw{j,1})
                    raw(j,:) = [];
                end
            end
            lbub = raw;
            
    end
end

if length(modelFileName)== 0
    disp('no model file');
end
if isempty(compartment)
    disp('no compartment found');
end
if isempty(biomassDrain)
    disp('no biomassDrain specified');
end
if isempty(metConnections)
    disp('no metConnections specified');
end
if isempty(objFxn)
    disp('no objective function specified');
end
if isempty(lbub)
    disp('no lb ub constraints specified');
end

