%clear all;clc;
load modelData

%%%%%%%%%%%%%%%%%%%%%
removeSingleton = 0;%1 or 0, %%%run this because overall slightly faster%%
writeToXLS = 1;%1 or 0
getMinRxnSet = 0;%this will take a while
%%%%%%%%%%%%%%%%%%%%%%%%

hitExt = strcmp(speciesBlock(:,5),'BIOM') + strcmp(speciesBlock(:,5),'BOUNDARY');
stoicBlock(:,find(hitExt==1))=[];

if removeSingleton
    [goodRxn singletonRxn singletonMet] = removeSingletons(stoicBlock);
    stoicBlock(singletonRxn,:) = [];
    stoicBlock(:,singletonMet) = [];
    f(singletonRxn) = [];
    if sum(abs(f))==0
        disp('warning, obj fxn is all zero, optimized rxn removed')
    end
    lbBlock(singletonRxn) = [];
    ubBlock(singletonRxn) = [];
end

beq = zeros(size(stoicBlock,2),1);

[x fval exitflag]=cplexlp(f,[],[],stoicBlock',beq,lbBlock,ubBlock);

fprintf('fval: %1.3f\n',fval);
fprintf('exitflag: %1.0f\n',exitflag);

if exitflag ~= 1
    return
end


%%find minimum reaction set%%
if getMinRxnSet
    rxnZeroFlux = find(x==0);
    p_taskToDo = 1;
    out = minSet(p_taskToDo,rxnZeroFlux, f, beq, lbBlock, ubBlock, stoicBlock, bValue);
    if length(out)>1
        xMin = out{3};
    end
end


if removeSingleton
    x_copy = x;
    x = zeros(size(rxnBlock,1),1);
    x(goodRxn) = round(x_copy*1e6)/1e6;
    try
        x_copy = xMin;
        xMin = zeros(size(rxnBlock,1),1);
        xMin(goodRxn) = round(x_copy*1e6)/1e6;
        x = [x xMin];
    end
end
save x.txt x -ascii


if writeToXLS
    if size(x,2) == 1
        fResultHead = {'flux'};
    elseif size(x,2) == 2
        fResultHead = {'flux' 'minSet'};
    end
    
    fResult = [fResultHead; num2cell(x)];
    stats = xlswrite('multiTissuesModel.xlsx',fResult,'rxns', 'K1');
    if stats == 0
        disp('flux results write failed');
    end
end
